<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/*
|--------------------------------------------------------------------------
| File and Directory Modes
|--------------------------------------------------------------------------
|
| These prefs are used when checking and setting modes when working
| with the file system.  The defaults are fine on servers with proper
| security, but you may wish (or even need) to change the values in
| certain environments (Apache running a separate process for each
| user, PHP under CGI with Apache suEXEC, etc.).  Octal values should
| always be used to set the mode correctly.
|
*/
define('FILE_READ_MODE', 0644);
define('FILE_WRITE_MODE', 0666);
define('DIR_READ_MODE', 0755);
define('DIR_WRITE_MODE', 0777);

/*
|--------------------------------------------------------------------------
| File Stream Modes
|--------------------------------------------------------------------------
|
| These modes are used when working with fopen()/popen()
|
*/

define('FOPEN_READ',							'rb');
define('FOPEN_READ_WRITE',						'r+b');
define('FOPEN_WRITE_CREATE_DESTRUCTIVE',		'wb'); // truncates existing file data, use with care
define('FOPEN_READ_WRITE_CREATE_DESTRUCTIVE',	'w+b'); // truncates existing file data, use with care
define('FOPEN_WRITE_CREATE',					'ab');
define('FOPEN_READ_WRITE_CREATE',				'a+b');
define('FOPEN_WRITE_CREATE_STRICT',				'xb');
define('FOPEN_READ_WRITE_CREATE_STRICT',		'x+b');

// Custom defines
function ot_define($key, $val){
	if (!defined($key))define($key, $val);
}

if (is_readable(FCPATH . APPPATH . 'config/client.constants.php'))
{
	include(FCPATH . APPPATH . 'config/client.constants.php');
}

ot_define('DS', DIRECTORY_SEPARATOR);
ot_define('TMP_PATH',	'tmp/');
ot_define('BACKUP_PATH',	'backup/');
ot_define('ASSETS_PATH',	'assets/');
ot_define('CSS_PATH',		'assets/css/');
ot_define('JS_PATH',		'assets/js/');
ot_define('FONT_PATH',		'assets/font/');
ot_define('IMAGE_PATH',	'assets/img/');
ot_define('NULL_IMAGE',	IMAGE_PATH	. 'nullimage.png');
ot_define('DOT_IMAGE',		IMAGE_PATH	. 'dot.png');
ot_define('NO_USER',		IMAGE_PATH	. 'noUser.png');
ot_define('OTBASE_PATH',	'base/');

ot_define('OUTPUT_UPDATE_URL', 'http://www.outputtime.com/releases/');

// Notification Port & Address Changes.
if (!defined('NOTIFY_ADDRESS') && !defined('NOTIFY_PORT'))
{
	$nAddress	= 'localhost';
	$nPort	= '8124';
	
	$ini_file	= FCPATH . 'conf.ini';
	if (file_exists($ini_file))
	{
		$ini_data	= parse_ini_file($ini_file, true);
		if (!empty($ini_data) && !empty($ini_data['notification']))
		{
			$data	= $ini_data['notification'];
			$nPort	= !empty($data['port']) ? $data['port'] : $nPort;
			$nAddress	= !empty($data['address']) ? $data['address'] : $nAddress;
		}
	}
	ot_define('NOTIFY_PORT', $nPort);
	ot_define('NOTIFY_ADDRESS', $nAddress);
}

/**
 * 
 * Version of OutputTime
 * 
 * major.minor.revision
 * 1.0.3340
 *
 * 
 * @var string
 */

define('OT_VERSION', "1.0.4913");

/* End of file constants.php */
/* Location: ./application/config/constants.php */
