<?php  if (!defined('BASEPATH')) exit('No direct script access allowed');

$config['domain_name'] = 'Output Time';

// Users configurations 
$config['SMX_signup_with_autologin']	= TRUE;
$config['SMX_autologin_cookie_life']	= 30;
$config['SMX_domain_suffix'] 			= '.outputtime.com';
$config['SMX_entity_user_role']			= 'A';
$config['SMX_entity_user_department']	= 'Administration';

$config['SMX_trial_lic_days']			= 30;

$config['SMX_trial_lic_saas']			= 60;

$config['user_role']	= array(
	'A'	=> 'Administrator',
	'F'	=> 'Project Manager + Finance',
	'P'	=> 'Project Manager',
	'M'	=> 'Member',
);
$config['default_user_role']	= 'M';

$config['items_per_page']		= 10;

$config['user_project_per_page']= 3;

$config['budget_type']	= array(
	'HA'	=> 'Total Project Hours',
	'HT'	=> 'Estimated Hours based on Task Type',
	'HP'	=> 'Estimated Hours based on People',
	'AA'	=> 'Total Project Amount',
	'AT'	=> 'Amount based on Task Estimated Hours',
	'AP'	=> 'Amount based on People Estimated Hours',
);
$config['default_budget_type']	= 'AT';

$config['invoice_types']	= array(
	'N'	=> 'Non Billable',
	'A'	=> 'Project All Hours',
	'T'	=> 'Task Hourly Rate',
	'P'	=> 'Person Hourly Rate',
);
$config['default_invoice_type']	= 'T';

$config['date_formats']	= array(
	'dd/MM/yyyy'	=> 'd/m/Y',
	'MM/dd/yyyy'	=> 'm/d/Y',
	'MMM dd, yyyy'	=> 'M d, Y',
	'yyyy-MM-dd'	=> 'Y-m-d',
);
$config['custom_date_formats']	= array(
	'dd/MM/yyyy'	=> 'dd/mm/yy',
);
$config['estimate_status']	= array(
	'd'	=> 'Draft',
	's'	=> 'Mark as Sent',
	'i'	=> 'Invoiced',
	'a'	=> 'Accepted',
	'r'	=> 'Rejected',
	'e'	=> 'Expired',
);
$config['invoice_status']	= array(
	'd'	=> 'Draft',
	's'	=> 'Mark as Sent',
	'p'	=> 'Paid',
	'b'	=> 'Partial',
);
$config['invoice_status_menu']	= array(
	'unpaid'	=> 'U',
	'draft'		=> 'D',
	'paid'		=> 'P',
	'recurring'	=> 'R',
	'archived'	=> 'A',
);
$config['status_class']	= array(
	'd'=>'btn-primary',
	's'=>'btn-warning',
	'i' =>'btn-info',
	'a'=>'btn-success',
	'r'=>'btn-danger',
	'e'=>'btn-default',
	'p'	=> 'btn-success',
	'b'	=> 'btn-info',
);

$config['due_date_mode'] = array(
	'D0'=>'Same as the invoice date', 
	'D7'=>'7 Days after the invoice date', 
	'D14'=>'Two weeks after the invoice date',
	'D15'=>'15 days after the invoice date', 
	'M1'=>'One month after the invoice date', 
	'M2'=>'Two months after the invoice date',
	'M3'=>'Three months after the invoice date', 
	'C'=>'Custom',
);
		
$config['recurring_mode'] = array(
	''=>'No Recurring', 
	'D7'=>'Every Week', 
	'D14'=>'Every 2 Weeks', 
	'D15'=>'Every 15 days', 
	'M1'=>'Every 1 month',
	'M2'=>'Every 2 months', 
	'M3'=>'Every 3 months', 
	'M4'=>'Every 4 months', 
	'M6'=>'Every 6 months', 
	'M12'=>'Every Year',
	'BMF'=>'First Day of each month', 
	'BML'=>'Last Day of each month', 
	'C'=>'Custom',
);

$config['number_formats']	= array(
	'N'	=> '123,456.78',
//	'D'	=> '123\'456.78',
	'F'	=> '123 456,78',
	'I'	=> '1,23,456.78',
);

$config['time_round_to']	= array(
	'N'	=> 'No roundup',
	'H'	=> 'Yes, round to half an hour',
	'F'	=> 'Yes, round to full hour',
);

$config['report_type']	= array(
	'index'		=> 'T',
	'time'		=> 'T',
	'task'		=> 'A',
	'invoice'	=> 'I',
	'budget'	=> 'BU',
	'expenses'	=> 'E'
);
$config['salt']	= 'SMX_UsErImAgE';

$config['addons_events'] = array(
	'IP' => 'Invoice Past Due Date',
	'PA' => 'Project Assigned',
	'PB' => 'Project Budget Alert',
	'TA' => 'Task Assigned',
	'TS' => 'Task Status Changed',
	'TD' => 'Task Due Date Changed',
	'TT' => 'Task Due Date Today',
	'TP' => 'Task Past Due Date',
	'CO' => 'Project / Task Comments',
	'AT' => 'Project / Task Attachments',
	'TU' => 'Task updated',
	'TR' => 'Timsesheet start',
	'TO' => 'Timsesheet stop'
);

$config['task_priority'] = array(1 => 'High', 2 => 'Medium', 3 => 'Low');

$config['protocal'] = 'http://';
if (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off' || $_SERVER['SERVER_PORT'] == 443) {
    $config['protocal'] = 'https://';
}
$config['renew_url'] = 'http://www.outputtime.com/index.php/buynow';

// $config['F_projects'] = $config['F_clients'] = $config['F_users'] = 3;
