<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');


class Request {
	
	public function __construct()
	{
		$this->CI 		= & get_instance();
	}
	
	public function get_type()
	{
		// check request from ajax
		if ($this->CI->input->is_ajax_request()){
				return 'AJAX';
		}
		
		$this->CI->load->library('user_agent');
		// check request from browser
		if ($this->CI->agent->is_browser())
		{
			return 'BROWSER';
		}
		
		if (preg_match("|".preg_quote('NuSOAP').".*?([0-9\.]+)|i", $this->CI->agent, $match))
		{
			return 'NUSOAP';
		}
		
		return '';
	}
	
	public function get_method()
	{
		return $this->CI->input->server('REQUEST_METHOD');
	}
	
	public function get_format()
	{
		// Get mime types for later
		if (defined('ENVIRONMENT') AND file_exists(APPPATH.'config/'.ENVIRONMENT.'/mimes.php'))
		{
		    include APPPATH.'config/'.ENVIRONMENT.'/mimes.php';
		}
		else
		{
			include APPPATH.'config/mimes.php';
		}
	
		$accept = $this->CI->input->get_request_header('Accept', TRUE);
		if ($accept)
		{
			$formats = array('html','json','xml');
			foreach ($formats as $key)
			{
				$val = !empty($mimes[$key])?$mimes[$key]:array();
				if (is_array($val))
				{
					foreach($val as $str){
						if (strpos($accept,$str)!==false)
						{
							$format = $key;
							break;
						}
					}
				} else if (strpos($accept,$val)!==false)
				{
					$format = $key;
					break;
				}
			}
		}
		return $format;
	}
	
	public function get_data()
	{
		if ($this->get_method()=='POST')
		{
			return $this->CI->input->post();
		}
		
		return $this->CI->input->get();
	}
}
