<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Dashboard_member extends CI_Model 
{
	public	$options	= array();
	
	function __construct()
	{
		parent::__construct();
	}
	
	
	public function get_task_status($data)
	{
		$this->db->select('count(pt.task_id) as count, pt.task_status_id', false);
		$this->db->from('project_task AS pt');
		$this->db->join('project_task_users as ptu', 'pt.task_id=ptu.task_id');
		$where = array('pt.entity_id'=>$this->ot_app->get('entity_id'));
		if (!empty($data['project_id']))
		{
			$where['pt.project_id'] = $data['project_id'];
		}
		$where['ptu.user_id'] = $this->ot_user->get('user_id');
		$this->db->where($where);
		$this->db->group_by('pt.task_status_id');
		$query = $this->db->get();

		return $query->result_array();
	}
	
	public function get_task_types($data = array())
	{
		$to_date   = $this->auth->get_timezone_date('Y-m-d');
		$from_date = date('Y-m-d', strtotime('-1 year', strtotime($to_date)));
		
		$this->db->select('sum(ts.hours) as hours, tt.name', false);
		$this->db->from('time_sheet as ts');
		$this->db->join('project as pr','ts.project_id = pr.project_id');
		$this->db->join('task_type as tt','ts.task_type_id = tt.task_type_id');
		$where = array('ts.entity_id' => $this->ot_app->get('entity_id'), 'ts.entry_date >=' => $from_date, 'ts.entry_date <=' => $to_date);
		if (!empty($data['project_id']))
		{
			$where['ts.project_id'] = $data['project_id'];
		}
		$where['ts.user_id'] = $this->ot_user->get('user_id');
		$this->db->where($where);
		$this->db->group_by('ts.task_type_id');
		$query = $this->db->get();
		
		return  $query->result_array();
	}
	
	
	public function get_milestones($data)
	{
	
		$cur_date	= $this->auth->get_timezone_date('Y-m-d', true);
		// today
		$sql = 'SUM(case when DATE_FORMAT(pt.finish_date, "%Y-%m-%d")="'.$cur_date.'" THEN 1 ELSE 0 END) AS "due_today"';
		// upcoming
		$sql.= ', SUM(case when DATE_FORMAT(pt.finish_date, "%Y-%m-%d")>"'.$cur_date.'" THEN 1 ELSE 0 END) AS "upcoming"';
		// overdue
		$sql.= ', SUM(case when DATE_FORMAT(pt.finish_date, "%Y-%m-%d")<"'.$cur_date.'" THEN 1 ELSE 0 END) AS "overdue"';
		$this->db->select($sql, false);
		$this->db->from('project_task AS pt');
		$this->db->join('project_task_users as ptu', 'pt.entity_id=ptu.entity_id and pt.task_id=ptu.task_id');
		$where = array('pt.entity_id'=>$this->ot_app->get('entity_id'), 'ptu.user_id' => $this->ot_user->get('user_id'), 'pt.is_closed !=' => 1, 'pt.is_milestone' => 1);
		if (!empty($data['project_id']))
			$where['pt.project_id'] = $data['project_id'];
		$this->db->where($where);

		$query = $this->db->get();

		return $query->result_array();
	}
	
	
	public function get_project_alerts()
	{
		$sql = 'pr.project_id, concat(pr.project_code, pr.project_name) AS project_name, pr.budget_type,pr.actual_value, pr.budget_value,pr.budget_alert_percent'
		.',SUM(IF (pt.estimated_hours AND pt.is_closed=0 AND pt.estimated_hours < worked_hours, 1, 0)) AS exe_estcnt'
		.',SUM(IF (!pt.estimated_hours && pt.is_closed=0 AND DATE_FORMAT(pt.start_date, "%Y-%m-%d") < "'.$this->auth->get_timezone_date('Y-m-d').'", 1, 0)) AS exe_datecnt';
		$this->db->select($sql, false);
		$this->db->from('project AS pr');
		$this->db->join('project_task as pt', 'pr.project_id=pt.project_id', 'LEFT');
		$this->db->join('project_users as pu', 'pu.project_id=pr.project_id');
		$where = array('pu.user_id' => $this->ot_user->get('user_id'), 'pr.entity_id'=>$this->ot_app->get('entity_id'));		
		$this->db->where($where);
		$this->db->group_by('pr.project_id');
		$query = $this->db->get();

		$result = $query->result_array();
		if ($result)
		{
			$project_alert = $pbt_split = array();			
			foreach ($result as $pr)
			{
				if ($pr['budget_type']=='HT' || $pr['budget_type']=='AT')
				{
					$pbt_split['pty'][] = $pr['project_id'];
				} else if ($pr['budget_type']=='HP' || $pr['budget_type']=='AP')
				{
					$pbt_split['pm'][] = $pr['project_id'];
				}
				$project_alert[$pr['project_id']] = $pr;
				$project_alert[$pr['project_id']]['types'] = array();
			}
			
			$pty_result = $pm_result = array();
			// get estimate and actual hours for task type based project task type
			if (!empty($pbt_split['pty'])) {
				$this->db->select('pty.project_id, pty.actual_hours as act_hrs, pty.estimated_hours, tt.name as name', false);
				$this->db->from('project_task_types as pty');
				$this->db->join('project_users as pu', 'pty.entity_id=pu.entity_id and pty.project_id=pu.project_id');
				$this->db->join('task_type as tt', 'pty.entity_id=tt.entity_id and pty.task_type_id=tt.task_type_id');
				$this->db->where(array('pty.entity_id'=>$this->ot_app->get('entity_id'), 'pu.user_id' =>$this->ot_user->get('user_id'), 'pty.estimated_hours <' =>  'pty.actual_value'));
				$this->db->where_in('pty.project_id', $pbt_split['pty']);
				$this->db->group_by('pty.project_task_type_id');
				$query = $this->db->get();

				$pty_result = $query->result_array();
				
				if ($pty_result)
				{
					foreach($pty_result as $pty)
					{
						$project_alert[$pty['project_id']]['types'][] = $pty;
					}
				}
			}
			
			// get estimate and actual hours for task type based project members
			if (!empty($pbt_split['pm'])) {
				$sql = 'pr.project_id, pu.estimated_hours, sum(ts.hours) AS act_hrs, eu.first_name AS name';
				$this->db->select($sql, false);
				$this->db->from('project AS pr');
				$this->db->join('project_users as pu', 'pr.project_id=pu.project_id');
				$this->db->join('time_sheet as ts', 'pu.user_id=ts.user_id AND pu.project_id=ts.project_id');
				$this->db->join('entity_users as eu', 'eu.user_id=ts.user_id');				
				$this->db->where(array('ts.entity_id'=>$this->ot_app->get('entity_id'),'ts.user_id' => $this->ot_user->get('user_id')));
				$this->db->where_in('pr.project_id', $pbt_split['pm']);
				$this->db->group_by('eu.user_id, pr.project_id');
				$query = $this->db->get();

				$pm_result = $query->result_array();
				if ($pm_result )
				{
					foreach($pm_result  as $pm)
					{
						if ($pm['estimated_hours']>$pm['act_hrs'])
							$project_alert[$pm['project_id']]['types'][] = $pm;
					}	
				}
			}		
			
			$result = array_values($project_alert);
		}

		return $result;
	}
	
	public function get_output_hours($data = array())
	{
		
		$where = array('ts.entity_id'=>$this->ot_app->get('entity_id'));
		$where['ts.user_id'] = $this->ot_user->get('user_id');
		if (!empty($data['from_date']) && !empty($data['from_date']))
		{
			$where['ts.entry_date >=']=$data['from_date'];
			$where['ts.entry_date <=']=$data['to_date'];
		}
		
		$date = 'DATE_FORMAT(ts.entry_date, "%Y-%m-%d") as group_entry';
		$diff = abs(strtotime($data['to_date']) - strtotime($data['from_date']));
		$years = floor($diff / (365*60*60*24));
		$months = floor(($diff - $years * 365*60*60*24) / (30*60*60*24));
		$days = floor(($diff - $years * 365*60*60*24 - $months*30*60*60*24)/ (60*60*24));
		
		if ($months>1) {
			$date = 'DATE_FORMAT(ts.entry_date, "%b") as group_entry';
		}else if($days > 7 || $months)
		{
			$date = 'DATE_FORMAT(ts.entry_date, "%e") as group_entry';
		}
		
		$this->db->select('sum(if(ts.is_billable=1, hours, 0)) AS billable_hours, sum(if(ts.is_billable!=1, hours, 0)) AS nonbillable_hours,'.$date, false);
		$this->db->from('project as pr');
		$this->db->join('time_sheet as ts', 'pr.project_id = ts.project_id');	
		$this->db->where($where);
		$this->db->group_by('group_entry');
		$this->db->order_by('ts.entry_date');
		
		$query = $this->db->get();
		//echo $this->db->last_query();exit;
		return $query->result_array();
	}
	
	public function get_status_color()
	{
		$this->db->select('name, bg_color, task_status_id');
		$this->db->from('task_status');
		$this->db->where(array('entity_id' => $this->ot_app->get('entity_id')));
		$query = $this->db->get();
		
		return $query->result_array();
	}
	
	public function get_project_hours($data)
	{
		$sql = 'sum(if(ts.is_billable=1,ts.hours,0)) as billable_hours, sum(if(ts.is_billable=0,ts.hours,0)) as nonbillable_hours, concat(pr.project_code, pr.project_name) as project_name';
		$this->db->select($sql, false);
		$this->db->from('time_sheet as ts');
		$this->db->join('project as pr','ts.project_id = pr.project_id');
		$where = array('ts.entity_id' => $this->ot_app->get('entity_id'), 'ts.user_id' => $this->ot_user->get('user_id'));
		if (!empty($data['from_date']) && !empty($data['to_date']))
		{
			$where['ts.entry_date >=']=$data['from_date'];
			$where['ts.entry_date <=']=$data['to_date'];
		}		
		$this->db->where($where);
		$this->db->group_by('pr.project_id');
		$this->db->order_by('pr.project_name');
		$query = $this->db->get();
		return $query->result_array();
	}
}
