<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

require_once(APPPATH . '/models/dashboard/mod.dashboard_member.php');

class Dashboard_pm extends Dashboard_member 
{
	public	$options	= array();
	
	function __construct()
	{
		parent::__construct();
	}
	
	public function get_task_status($data = array())
	{
		$this->db->select('count(pt.task_id) as count, pt.task_status_id', false);
		$this->db->from('project_task AS pt');
		$this->db->join('project_users as pru', 'pt.entity_id=pru.entity_id and pt.project_id=pru.project_id');
		$where = array('pt.entity_id'=>$this->ot_app->get('entity_id'));
		if (!empty($data['project_id']))
		{
			$where['pt.project_id'] = $data['project_id'];
		}
		$where['pru.user_id'] = $this->ot_user->get('user_id');
		$this->db->where($where);
		$this->db->group_by('pt.task_status_id');
		$query = $this->db->get();

		return $query->result_array();
	}
	
	
	public function get_task_types($data = array())
	{
		$this->db->select('pty.actual_hours as hours,tt.name');
		$this->db->from('project_task_types as pty');
		$this->db->join('task_type as tt','pty.entity_id=tt.entity_id and pty.task_type_id = tt.task_type_id');
		$this->db->join('project_users as pru', 'pty.entity_id=pru.entity_id and pty.project_id=pru.project_id');
		$where = array('pty.entity_id' => $this->ot_app->get('entity_id'));
		if (!empty($data['project_id']))
		{
			$where['pty.project_id'] = $data['project_id'];
		}
		$where['pru.user_id'] = $this->ot_user->get('user_id');
		$this->db->where($where);
		$this->db->group_by('pty.task_type_id');
		$query = $this->db->get();
		//echo $this->db->last_query();exit;
		return  $query->result_array();
	}
	
	
	public function get_output_hours($data = array())
	{
		$project_ids = array();	
		$where = array('entity_id'=>$this->ot_app->get('entity_id'));
		
		if (!empty($data['from_date']) && !empty($data['from_date']))
		{
			$where['entry_date >=']=$data['from_date'];
			$where['entry_date <=']=$data['to_date'];
		}
		
		$date = 'DATE_FORMAT(entry_date, "%Y-%m-%d") as group_entry';
		$diff = abs(strtotime($data['to_date']) - strtotime($data['from_date']));
		$years = floor($diff / (365*60*60*24));
		$months = floor(($diff - $years * 365*60*60*24) / (30*60*60*24));
		$days = floor(($diff - $years * 365*60*60*24 - $months*30*60*60*24)/ (60*60*24));
		
		if ($months>1) {
			$date = 'DATE_FORMAT(entry_date, "%b") as group_entry';
		}else if($days > 7 || $months)
		{
			$date = 'DATE_FORMAT(entry_date, "%e") as group_entry';
		}
		

		if (empty($data['team_view']))
		{
			$where['user_id'] = $this->ot_user->get('user_id');
		} else {
			$this->load->model('projects');
			$projects	= $this->projects->get_projects('pr.project_id,pr.project_name', array('filters'=>array('pr.is_active' => 1,'pru.user_role !=' => 'M')));
			/*$this->load->model('timesheets');
			$users = $this->timesheets->get_team_users('DISTINCT eu.user_id');*/
			if (!$projects) return false;
			
			foreach($projects as $row) {
				$project_ids[] = $row['project_id'];
			}
		}		
		
		
		$this->db->select('sum(if(is_billable=1, hours, 0)) AS billable_hours, sum(if(is_billable!=1, hours, 0)) AS nonbillable_hours,'.$date, false);
		$this->db->from('time_sheet');	
		
		$this->db->where($where);
		if ($project_ids)
			$this->db->where_in('project_id', $project_ids);
		$this->db->group_by('group_entry');
		$this->db->order_by('entry_date');
		$query = $this->db->get();
		//echo $this->db->last_query();exit;
		return $query->result_array();
	}
	
	public function get_project_hours($data)
	{
		$this->load->model('timesheets');
		$users = $this->timesheets->get_team_users('DISTINCT eu.user_id');
		if (!$users) return false;
		
		foreach($users as $user) {
			$user_ids[] = $user['user_id'];
		}
				
		$sql = 'sum(if(ts.is_billable=1,ts.hours,0)) as billable_hours, sum(if(ts.is_billable=0,ts.hours,0)) as nonbillable_hours, concat(pr.project_code, pr.project_name) as project_name';
		$this->db->select($sql, false);
		$this->db->from('time_sheet as ts');
		$this->db->join('project as pr','ts.project_id = pr.project_id');
		$where = array('ts.entity_id' => $this->ot_app->get('entity_id'));
		if (!empty($data['from_date']) && !empty($data['to_date']))
		{
			$where['ts.entry_date >=']=$data['from_date'];
			$where['ts.entry_date <=']=$data['to_date'];
		}
		$this->db->where($where);
		$this->db->where_in('ts.user_id', $user_ids);
		$this->db->group_by('pr.project_id');
		$this->db->order_by('pr.project_name');
		$query = $this->db->get();
		return $query->result_array();
	}
	
	public function get_project_alerts()
	{
		$sql = 'pr.project_id, concat(pr.project_code, pr.project_name) AS project_name, pr.budget_type,pr.actual_value, pr.budget_value,pr.budget_alert_percent'
		.',SUM(IF (pt.estimated_hours AND pt.is_closed=0 AND pt.estimated_hours < worked_hours, 1, 0)) AS exe_estcnt'
		.',SUM(IF (!pt.estimated_hours && pt.is_closed=0 AND DATE_FORMAT(pt.start_date, "%Y-%m-%d") < "'.$this->auth->get_timezone_date('Y-m-d').'", 1, 0)) AS exe_datecnt';
		$this->db->select($sql, false);
		$this->db->from('project AS pr');
		$this->db->join('project_task as pt', 'pt.entity_id=pr.entity_id  and pr.project_id=pt.project_id', 'LEFT');
		$this->db->join('project_users as pu', 'pr.entity_id=pu.entity_id and pu.project_id=pr.project_id');
		$where = array('pr.entity_id'=>$this->ot_app->get('entity_id'), 'pu.user_id' => $this->ot_user->get('user_id'), 'pr.is_active' => 1);
		$this->db->where($where);
		$this->db->group_by('pr.project_id');
		$query = $this->db->get();

		$result = $query->result_array();
		if ($result)
		{
			$project_alert = $pbt_split = array();			
			foreach ($result as $pr)
			{
				if ($pr['budget_type']=='HT' || $pr['budget_type']=='AT')
				{
					$pbt_split['pty'][] = $pr['project_id'];
				} else if ($pr['budget_type']=='HP' || $pr['budget_type']=='AP')
				{
					$pbt_split['pm'][] = $pr['project_id'];
				}
				$project_alert[$pr['project_id']] = $pr;
				$project_alert[$pr['project_id']]['types'] = array();
			}
			
			$pty_result = $pm_result = array();
			// get estimate and actual hours for task type based project task type
			if (!empty($pbt_split['pty'])) {
				$this->db->select('pty.project_id, pty.actual_hours as act_hrs, pty.estimated_hours, tt.name as name', false);
				$this->db->from('project_task_types as pty');
				$this->db->join('task_type as tt', 'pty.entity_id=tt.entity_id and pty.task_type_id=tt.task_type_id');
				$this->db->where(array('pty.entity_id'=>$this->ot_app->get('entity_id'), 'pty.estimated_hours <' =>  'pty.actual_hours'), NULL, FALSE);
				$this->db->where_in('pty.project_id', $pbt_split['pty']);
				$this->db->group_by('pty.project_task_type_id');
				$query = $this->db->get();

				$pty_result = $query->result_array();
				
				if ($pty_result)
				{
					foreach($pty_result as $pty)
					{
						$project_alert[$pty['project_id']]['types'][] = $pty;
					}
				}
			}
			
			// get estimate and actual hours for task type based project members
			if (!empty($pbt_split['pm'])) {
				$this->db->select('pru.project_id, pru.actual_hours as act_hrs, pru.estimated_hours, eu.first_name as name', false);
				$this->db->from('project_users as pru');
				$this->db->join('entity_users as eu', 'eu.entity_id=pru.entity_id and eu.user_id=pru.user_id');
				$this->db->where(array('pru.entity_id' => $this->ot_app->get('entity_id'), 'pru.estimated_hours <' =>  'pru.actual_hours'), NULL, FALSE);
				$this->db->where_in('pru.project_id', $pbt_split['pm']);
				$this->db->group_by('pru.project_id, pru.user_id');
				$query = $this->db->get();

				$pm_result = $query->result_array();
				//echo $this->db->last_query();
				if ($pm_result )
				{
					foreach($pm_result  as $pm)
					{
						$project_alert[$pm['project_id']]['types'][] = $pm;
					}	
				}
			}		
			
			$result = array_values($project_alert);
		}

		return $result;
	}

	public function get_milestones($data)
	{
	
		$cur_date	= $this->auth->get_timezone_date('Y-m-d', true);
		// today
		$sql = 'SUM(case when DATE_FORMAT(pt.finish_date, "%Y-%m-%d")="'.$cur_date.'" THEN 1 ELSE 0 END) AS "due_today"';
		// upcoming
		$sql.= ', SUM(case when DATE_FORMAT(pt.finish_date, "%Y-%m-%d")>"'.$cur_date.'" THEN 1 ELSE 0 END) AS "upcoming"';
		// overdue
		$sql.= ', SUM(case when DATE_FORMAT(pt.finish_date, "%Y-%m-%d")<"'.$cur_date.'" THEN 1 ELSE 0 END) AS "overdue"';
		$this->db->select($sql, false);
		$this->db->from('project_task AS pt');
		$this->db->join('project_users as ptu', 'pt.entity_id=ptu.entity_id and pt.project_id=ptu.project_id');
		$where = array('pt.entity_id'=>$this->ot_app->get('entity_id'), 'ptu.user_id' => $this->ot_user->get('user_id'), 'pt.is_closed !=' => 1, 'pt.is_milestone' => 1);
		if (!empty($data['project_id']))
			$where['pt.project_id'] = $data['project_id'];
		$this->db->where($where);

		$query = $this->db->get();

		return $query->result_array();
	}
}
