<?php
	error_reporting(E_ALL);

	define('DS', DIRECTORY_SEPARATOR);

	set_time_limit(0);

	ob_implicit_flush();

	$max_client_handle	= 50;

	$log_file	= __DIR__ . '/logs/sock.log';
	$address	= 'localhost';
	$port	= 8124;

	$conf_file	= __DIR__ . "/../../../conf.ini";
	if (@file_exists($conf_file))
	{
		$ini_data	= parse_ini_file($conf_file, true);
		if (!empty($ini_data) && !empty($ini_data['notification']))
		{
			$data	= $ini_data['notification'];
			$port	= !empty($data['port']) ? $data['port'] : $port;
			$address	= !empty($data['address']) ? $data['address'] : $address;
			$log_file	= !empty($data['log_path']) ? $data['log_path'] . '/sock.log' : $log_file;
			echolog("INI Record available.");
		}
	}
	else
	{
		echolog("INI file not available.");
	}

	function echolog($msg='', $is_exit=false)
	{
		global $log_file;
		echo $msg . PHP_EOL;
		file_put_contents($log_file, date('Y-m-d h:i:s') . "	=> " . $msg . PHP_EOL, FILE_APPEND);
		if ($is_exit)
		{
			exit;
		}
	}

	if (empty($argv[1]))
	{
		$php_exec	= 'php';
// 		echolog('PHP exe path missing in arguement.', true);
	}
	else
	{
		$php_exec	= $argv[1];
	}

	function new_message_arrived($msg='')
	{
		if (empty($msg))
		{
			return false;
		}
		global $php_exec;
		execInBackground($php_exec . ' "' . __DIR__ . '/../../../index.php" home notification "' . base64_encode($msg) . '"');
	}

	function execInBackground($cmd)
	{
		echolog('Executing : ' . $cmd);

		if (substr(php_uname(), 0, 7) == "Windows")
		{
			pclose(popen("start /B ". $cmd, "r"));
		}
		else
		{
			exec($cmd . " > /dev/null &");
		}
	}

	function isPortFree($ip, $port) {
		try {
			$socket	= socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
			if ($socket === false) {
				return true;
			}
			if (socket_connect($socket, $ip, $port) === false) {
				return true;
			}

			socket_close($socket);
			return false;
		} catch(Exception $e) {
			return true;
		}
	}
	
	if (!isPortFree($address, $port)) {
		echolog("Already port opened : " . $port);
		exit;
	}
/*
	//region Socket begin
	if (!empty($argv[2]))
	{
		$address	= $argv[2];
	}
	else if (getenv('OT_NOTIFICATION_IP'))
	{
		$address	= getenv('OT_NOTIFICATION_IP');
	}
	else
	{
		$address	= '127.0.0.1';
	}

	if (!empty($argv[3]))
	{
		$port	= $argv[3];
	}
	else if (getenv('OT_NOTIFICATION_PORT'))
	{
		$port	= getenv('OT_NOTIFICATION_PORT');
	}
	else
	{
		$port	= 8080;
	}
*/
	

	echolog("Creating Socket.");
	if (($sock = socket_create(AF_INET, SOCK_STREAM, SOL_TCP)) === false)
	{
		echolog("socket_create() failed: reason: " . socket_strerror(socket_last_error()));
	}

	if ( !socket_set_option($sock, SOL_SOCKET, SO_REUSEADDR, 1))
	{
		echolog("socket_set_option() failed : " . socket_strerror(socket_last_error($sock)), true);
	}

	if (socket_bind($sock, $address, $port) === false)
	{
		echolog("socket_bind() failed : " . socket_strerror(socket_last_error($sock)));
	}

	if (socket_listen($sock, 5) === false)
	{
		echolog("socket_listen() failed : " . socket_strerror(socket_last_error($sock)));
	}

	echolog("Socket listen on " . $address . ":" . $port);

	do {
		if (($msgsock = socket_accept($sock)) === false)
		{
			echolog("socket_accept() failed: reason: " . socket_strerror(socket_last_error($sock)));
			break;
		}

		echolog('New Socket Accepted.');

		$msg	= '';
		do {
			$buffer = '';
			$bytes	= @socket_recv($msgsock, $buffer, 4096, 0);
			if ($bytes > 0)
			{
				$msg	.= $buffer;
			}
			else
			{
				break;
			}
		} while (true);
		socket_close($msgsock);

		new_message_arrived($msg);

	} while (true);

	socket_close($sock);
	echolog('Socket Closed.');
	//region Socket End
?>
