<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed'); 
	
	$fields	= array(
		'project_name'	=> array(
			'id'			=> 'project_name',
			'name'			=> 'project_name',
			'class'			=> 'form-control input-sm',
			'data-bind'		=> 'value:project_name',
			'placeholder'	=> lang('PROJECT_NAME'),
		),
		'project_code'	=> array(
			'id'			=> 'project_code',
			'name'			=> 'project_code',
			'class'			=> 'form-control input-sm',
			'data-bind'		=> 'value:project_code',
			'maxlength'		=> '6',
			'placeholder'	=> lang('PROJECT_CODE'),
		),
		'clients'		=> array(
			'id'			=> 'client_id',
			'name'			=> 'client_id',
			'class'			=> 'input-sm select form-control',
			'value'			=> '',
			'extra'			=> 'data-bind="value:client_id"',
		),
		'is_active'		=> array(
		    'name'        => 'is_active',
		    'id'          => 'is_active',
		    'value'       => 'accept',
			'data-bind'	  => 'checked:is_active',
		    'style'       => 'margin:10px',
	    ),
	    'description'		=> array(
		    'id'			=> 'description',
			'name'			=> 'description',
			'class'			=> 'col-lg-12 form-control',
			'data-bind'		=> 'value:description',
			'placeholder'	=> lang('DESCRIPTION'),
	    )	
	);
?>
<div class="panel sidebar-fixed-header panel-primary" data-bind="with:project">
	<div class="panel-heading">
		<h3 class="panel-title pull-left with-btn"><?php echo lang('ADD_NEW_PROJECT'); ?></h3>
		<div class="pull-right">
			<button class="btn btn-sm btn_save btn-success" id="save" data-bind="click:$parent.save"><i class="icon icon-save icon-white"></i>&nbsp;&nbsp;<?php echo lang('SAVE'); ?></button>
			<button class="btn btn-sm btn-danger" id="cancel" data-bind="click:$parent.cancel"><?php echo lang('CANCEL'); ?></button>
		</div>
	</div>
	<div class="panel-body">
		<div class="row">
			<div class="col-lg-12">
				<div class="control-group">
					<div class="errorMsg">
					</div>
				</div>
			</div>
		</div>
		<div class="row">
			<div class="col-md-12">
				<div class="form-group input-group">
					<i class="input-group-addon input-sm"><?php echo lang('Name'); ?>&nbsp;</i>
					<?php echo form_input($fields['project_name']);?>
				</div>
			</div>
		</div>
		<div class="row">
			<div class="col-md-8">
				<div class="form-group input-group">
					<i class="input-group-addon input-sm"><?php echo lang('CODE'); ?>&nbsp;&nbsp;</i>
					<?php echo form_input($fields['project_code']); ?>
				</div>
			</div>
		</div>
		<div class="row">
			<div class="col-md-11">
				<div class="form-group input-group select_client">
					<i class="input-group-addon input-sm"><?php echo lang('CLIENT'); ?>&nbsp;</i>
					<select class="input-sm form-control" id="select_clients" data-bind="options:$parent.clients, optionsText:'client_name', optionsValue:'client_id', value:client_id, optionsCaption: 'Select any client...'"></select>
				</div>
			</div>
		</div>
		<!-- div class="row">
			<div class="col-lg-12">
				<label for="is_active">
					<?php echo form_checkbox($fields['is_active']); ?>
					<span><?php echo lang('ACTIVE'); ?></span>
				</label>
			</div>
		</div -->
		<div class="row">
			<div class="col-lg-12">
				<?php echo form_textarea($fields['description']);?>
			</div>
		</div>
	</div>
</div>
